<?php
/**
 * @version		3.0
 * @package		Joomla
 * @subpackage	Payment Form
 * @author  Tuan Pham Ngoc
 * @copyright	Copyright (C) 2010 Ossolution Team
 * @license		GNU/GPL, see LICENSE.php
 */
// Check to ensure this file is included in Joomla!
defined('_JEXEC') or die( 'Restricted access' );
/**
 * Payment Form controller
 *
 * @package		Joomla
 * @subpackage	Payment Form
 * @since 1.5
 */
class PmFormController extends JControllerLegacy
{
	/**
	 * Constructor function
	 *
	 * @param array $config
	 */
	function __construct($config = array())
	{		
		parent::__construct($config);						
		$this->registerTask('save2new_form', 'save_form');
		$this->registerTask('apply_form', 'save_form');			
		$this->registerTask('save2new_field', 'save_field');
		$this->registerTask('apply_field', 'save_field');
	}
	/**
	 * Display information
	 *
	 */
	function display( )
	{	
		$task = $this->getTask();	
		$document = JFactory::getDocument() ;
		$document->addStyleSheet(JURI::base().'components/com_pmform/assets/css/style.css');
		if (version_compare(JVERSION, '3.0', 'lt')) {	
			PmFormHelper::loadBootstrap();
		}
		switch ($task) {						
			case 'add'     :					
				JRequest::setVar( 'view'  , 'payment');
				JRequest::setVar( 'edit', false );				
				break;
			case 'edit'    :			
				JRequest::setVar('view', 'payment');								
				JRequest::setVar( 'edit', true );				
				break;				
			case 'edit_plugin' :
				JRequest::setVar('view', 'plugin') ;
				JRequest::setVar('hidemainmenu', 1) ;
				JRequest::setVar('edit', true) ;
				break ;						
			case 'add_form':							
				JRequest::setVar( 'view'  , 'form');
				JRequest::setVar( 'edit', false );
				break;	
			case 'edit_form':
				JRequest::setVar( 'view'  , 'form');
				JRequest::setVar( 'edit', true );
				break;							
				break ;
			case 'add_field' :				
				JRequest::setVar('view', 'field');
				JRequest::setVar( 'edit', false );
				break ;
			case 'edit_field' :				
				JRequest::setVar('view', 'field');
				JRequest::setVar( 'edit', true );
				break ;			
			case 'add_coupon':
				JRequest::setVar( 'hidemainmenu', 1 );				
				JRequest::setVar( 'view'  , 'coupon');
				JRequest::setVar( 'edit', false );
				break;	
			case 'edit_coupon':
				JRequest::setVar( 'hidemainmenu', 1 );				
				JRequest::setVar( 'view'  , 'coupon');
				JRequest::setVar( 'edit', true );
				break;				
			case 'translation' :				
				JRequest::setVar('view', 'language');
				break ;										
			default:
			    $view = JRequest::getVar('view', '');
			    if (!$view)
				    JRequest::setVar('view', 'payments');
				break;					 	 
		}
		parent::display();
		PmFormHelper::displayCopyRight();		
		if (version_compare(JVERSION, '1.6.0', 'ge')) {
		    PmFormHelper::addSubmenus(JRequest::getVar('view', 'payments'));
		}
	}
	/**	
	 * Save configuration data
	***/
	function save_configuration() {						
		$data = JRequest::get('post', JREQUEST_ALLOWHTML) ;
		unset($data['option']) ;
		unset($data['task']) ;		
		$model = & $this->getModel('configuration');
		$ret = $model->store($data);
		if ($ret) {
			$msg = JText::_('Configuration data saved');
		} else {
			$msg =  JText::_('Error saving configuration data');
		}
		$this->setRedirect('index.php?option=com_pmform&view=configuration', $msg);
	}		
	/**
	 * Save donation record
	 *
	 */
	function save_payment() {
		$post = JRequest::get('post');
		$cid = JRequest::getVar('cid', array());
		$post['id'] = (int) $cid[0];		
		$model = & $this->getModel('payment');
		$ret = $model->store($post);		
		if ($ret)
			$msg = JText::_('Payment record saved');
		else
			$msg = JText::_('Error saving payment record');
		$this->setRedirect('index.php?option=com_pmform&view=payments', $msg);	
	}
	/**
	 * Remove selected donors from database
	 *
	 */
	function remove() {
		$cid = JRequest::getVar('cid', array(), 'post');
		JArrayHelper::toInteger($cid);
		$model = & $this->getModel('payment');
		$ret = $model->delete($cid);
		if ($ret) 
			$msg = JText::_('Payment records removed');
		else
			$msg = JText::_('Error removing payment records');		
		$this->setRedirect('index.php?option=com_pmform&view=payments', $msg);
	}	
	/**
	 * Publish selected donors
	 *
	 */		
	function payments_publish() {
		$cid = JRequest::getVar('cid', array(), 'post');
		JArrayHelper::toInteger($cid);		
		$model = & $this->getModel('payment');
		$model->publish($cid , 1);
		$msg = JText::_('Payemnts successfully published');
		$url = 'index.php?option=com_pmform&view=payments';
		$this->setRedirect($url, $msg);
	}
	/**
	 * Unpublish donors
	 *
	 */
	function payments_unpublish() {
		$cid = JRequest::getVar('cid', array(), 'post');
		JArrayHelper::toInteger($cid);		
		$model = & $this->getModel('payment');
		$model->publish($cid , 0);
		$msg = JText::_('Payments successfully unpublished');
		$url = 'index.php?option=com_pmform&view=payments';
		$this->setRedirect($url, $msg);
	}
	/**
	 * Export data to csv file
	 *
	 */
	function csv_export() {
		$db = JFactory::getDBO();
		$config = PmFormHelper::getConfig() ;
		$formId = JRequest::getInt('form_id', 0) ;				
		$where = array() ;
		$where[] = '(a.published = 1 OR a.payment_method="os_offline")';
		if ($formId) {
			$where[] = ' a.form_id = '.$formId ;
		}
		//Get list of payment record records
		if ($config->show_coupon) {
			$sql = 'SELECT a.* , b.title, c.username, d.code AS coupon_code FROM #__pf_payments AS a LEFT JOIN #__pf_forms AS b ON a.form_id=b.id LEFT JOIN #__users AS c ON a.user_id = c.id LEFT JOIN #__pf_coupons AS d ON a.coupon_id = d.id  WHERE '
			.implode(' AND ', $where)
			.
			' ORDER BY a.form_id, a.created_date DESC ';
		} else {
			$sql = 'SELECT a.* , b.title, c.username FROM #__pf_payments AS a LEFT JOIN #__pf_forms AS b ON a.form_id=b.id LEFT JOIN #__users AS c ON a.user_id = c.id WHERE '
			.implode(' AND ', $where)
			.
			' ORDER BY a.form_id, a.created_date DESC ';
		}
		
		$db->setQuery($sql);
		$rows = $db->loadObjectList();
		//Exports all core fields
		$keys = array('s_lastname', 's_organization', 's_address', 's_address2', 's_city', 's_state', 's_zip', 's_country', 's_phone', 's_fax');					
		foreach ($keys as $key) {
			$config->$key = 1 ;
		}
		if(count($rows)){
			$jcFields = new JCFields($formId);
			$results_arr=array();										
			$csv_output = "Form Title, Username, First name ";
			if ($config->s_lastname)
				$csv_output .= ", Last name";		
			if ($config->s_organization) 
				$csv_output .= ', Organization ';
			if ($config->s_address)
				$csv_output .= ', Address ';
			if ($config->s_address2)
				$csv_output .= ', Address2 ';	
			if ($config->s_city)
				$csv_output .= ', City ';
			if ($config->s_state)
				$csv_output .= ', State ';			
			if ($config->s_zip)
				$csv_output .= ', Zip ';
			if ($config->s_country)
				$csv_output .= ', Country ';
			if ($config->s_phone)
				$csv_output .= ', Phone ';			
			if ($config->s_fax)
				$csv_output .= ', Fax ';	
			$csv_output .= ', Email ';												
			$csv_output .= ', Payment Amount ';
			$csv_output .= ', Discount Amount ';
			$csv_output .= ', Payment Date ';
			if ($config->show_coupon) {
				$csv_output .= ', Coupon Code ';
			}
			$csv_output .= ', Payment method ';
			$csv_output .= ', Transaction ID ';
			if ($config->s_comment)
				$csv_output .= ', Comment ';	
			if ($jcFields->getTotal()) {
				$fields = $jcFields->_fields ;
				for ($i = 0 , $n = count($fields) ; $i < $n ; $i++) {
					$field = $fields[$i] ;
					if ($field->is_core)
						continue ;
					$csv_output .= ', '.$field->title ;														
				}				
			}
			foreach($rows as $r) {
				$results_arr=array();
				$results_arr[]= $r->title ;		
				$results_arr[] = $r->username ; 										
				$results_arr[]= $r->first_name ;
				if ($config->s_lastname)
					$results_arr[]=$r->last_name ;
				if ($config->s_organization)
					$results_arr[]=$r->organization;
				if ($config->s_address)
					$results_arr[]=$r->address;
				if ($config->s_address2)
					$results_arr[]=$r->address2;	
				if ($config->s_city)
					$results_arr[]=$r->city;
				if ($config->s_state)
					$results_arr[]=$r->state;	
				if ($config->s_zip)
					$results_arr[]=$r->zip;
				if ($config->s_country)
					$results_arr[]=$r->country;
				if ($config->s_phone)
					$results_arr[]=$r->phone;								
				if ($config->s_fax)
					$results_arr[]=$r->fax;	
				$results_arr[]=$r->email;																	
				$results_arr[]= number_format($r->amount, 2);				
				$results_arr[]= number_format($r->discount_amount, 2);
				$results_arr[]= JHTML::_('date', $r->created_date, '%m-%d-%Y');
				if ($config->show_coupon) {
					$results_arr[]= $r->coupon_code ;
				}
				if ($r->payment_method == 'os_paypal')
					$results_arr[] = JText::_('Paypal');
				elseif ($r->payment_method == 'os_authnet')
					$results_arr[] = JText::_('Authorize.net');
				elseif ($r->payment_method == 'os_moneybooker')					
					$results_arr[] = JText::_('Moneybooker');	
				elseif ($r->payment_method == 'os_eway')					
					$results_arr[] = JText::_('Eway');	
				else
					$results_arr[] = $r->payment_method;
				$results_arr[] = $r->transaction_id ;						
				if ($config->s_comment)
					$results_arr[]= $r->comment;				
				if ($jcFields->getTotal()) {
					$sql = 'SELECT field_id, field_value FROM #__pf_field_value WHERE payment_id='.$r->id;
					$db->setQuery($sql);
					$rowFields = $db->loadObjectList();
					$values = array();
					for ($i = 0 , $n = count($rowFields) ; $i < $n ; $i++) {
						$rowField = $rowFields[$i] ;
						$values[$rowField->field_id] = $rowField->field_value ;
					}																				
					$fields = $jcFields->_fields ;
					for ($i = 0 , $n = count($fields) ; $i < $n ; $i++) {
						$field = $fields[$i] ;
						if ($field->is_core)
							continue ;
						if (isset($values[$field->id]))
							$value = $values[$field->id] ;
						else 
							$value = '' ;
						$results_arr[] = $value ;									
					}
				}															
				$csv_output .= "\n\"".implode ("\",\"", $results_arr)."\"";				
			}
			$csv_output .= "\n";	
			if (ereg('Opera(/| )([0-9].[0-9]{1,2})', $_SERVER['HTTP_USER_AGENT'])) {
				$UserBrowser = "Opera";
			}
			elseif (ereg('MSIE ([0-9].[0-9]{1,2})', $_SERVER['HTTP_USER_AGENT'])) {	
				$UserBrowser = "IE";
			} else {
				$UserBrowser = '';	}	
				$mime_type = ($UserBrowser == 'IE' || $UserBrowser == 'Opera') ? 'application/octetstream' : 'application/octet-stream';
				$filename = "payment_records";	
				@ob_end_clean();	
				ob_start();	
				header('Content-Type: ' . $mime_type);	
				header('Expires: ' . gmdate('D, d M Y H:i:s') . ' GMT');	
				if ($UserBrowser == 'IE') {
					header('Content-Disposition: attachment; filename="' . $filename . '.csv"');
					header('Cache-Control: must-revalidate, post-check=0, pre-check=0');
					header('Pragma: public');
				}
				else {
					header('Content-Disposition: attachment; filename="' . $filename . '.csv"');
					header('Pragma: no-cache');
				}
				print $csv_output;
				exit();
		}			
	}
	/**
	 * Save the campaing
	 */
	function save_form() {
		$post = JRequest::get('post', JREQUEST_ALLOWRAW);
		$cid = JRequest::getVar('cid', array());
		$post['id'] = (int) $cid[0];		
		$model = & $this->getModel('form');
		$ret = $model->store($post);
		$id = JRequest::getInt('id', 0) ;
		$task = $this->getTask() ;
		switch ($task) {
			case 'apply_form' :
				$url = 'index.php?option=com_pmform&task=edit_form&cid[]='.$id ;
				break ;
			case 'save2new_form' :
				$url = 'index.php?option=com_pmform&task=add_form';
				break ;
			default:
				$url = 'index.php?option=com_pmform&view=forms';
				break ;						
		}
		if ($ret)
			$msg = JText::_('Form saved');
		else
			$msg = JText::_('Error saving form');
		$this->setRedirect($url, $msg);	
	}
	/**
	 * Copy a form	 
	 */
	function copy_form() {
		$cid = JRequest::getVar('cid', array(), 'post');
		JArrayHelper::toInteger($cid);
		$model =  $this->getModel('form');
		$id = $model->copy($cid[0]);		
		$msg = JText::_('Form was successfully copied');		
		$url = 'index.php?option=com_pmform&task=edit_form&cid[]='.$id;
		$this->setRedirect($url, $msg);	
	}
	/**
	 * Remove the selected campaigns
	 *
	 */
	function remove_forms() {
		$cid =  JRequest::getVar('cid', array(), 'post');
		JArrayHelper::toInteger($cid);
		$model = & $this->getModel('form');
		$ret = $model->delete($cid);
		if ($ret) 
			$msg = 'Forms successfully removed';
		else 
			$msg = 'Error while removing Forms';
		$url = 'index.php?option=com_pmform&view=forms';
		$this->setRedirect($url, $msg);							
	}
	/**
	 * Publish a campaign
	 *
	 */
	function publish() {
		$cid = JRequest::getVar('cid', array(), 'post');
		JArrayHelper::toInteger($cid);		
		$model = & $this->getModel('form');
		$model->publish($cid , 1);
		$msg = JText::_('Form successfully published');
		$url = 'index.php?option=com_pmform&view=forms';
		$this->setRedirect($url, $msg);
	}
	/**
	 * Order up form
	 *
	 */
	function orderup()
	{	
		$model = & $this->getModel('form');
		$model->move(-1);
		$this->setRedirect( 'index.php?option=com_pmform&view=forms');
	}
	/**
	 * Order down campaign
	 *
	 */
	function orderdown()
	{		
		$model = $this->getModel('form');
		$model->move(1);
		$this->setRedirect( 'index.php?option=com_pmform&view=forms');
	}
	/**
	 * Save orders of campaigns
	 *
	 */
	function saveorder()
	{		
		$cid 	= JRequest::getVar( 'cid', array(), 'post', 'array' );
		$order 	= JRequest::getVar( 'order', array(), 'post', 'array' );
		JArrayHelper::toInteger($cid);
		JArrayHelper::toInteger($order);
		$model = $this->getModel('form');
		$model->saveorder($cid, $order);
		$msg = JText::_('New ordering saved' );
		$this->setRedirect('index.php?option=com_pmform&view=forms', $msg );
	}
	
	/**
	 * Unpublish a form
	 *
	 */
	function unpublish() {
		$cid = JRequest::getVar('cid', array(), 'post');
		JArrayHelper::toInteger($cid);
		$model = & $this->getModel('form');
		$model->publish($cid , 0);
		$msg = JText::_('Form successfully unpublished');
		$url = 'index.php?option=com_pmform&view=forms';
		$this->setRedirect($url, $msg);
	}	
	/**
	 * Cancel the form
	 *
	 */
	function cancel_form() {		
		$url = 'index.php?option=com_pmform&view=forms';
		$this->setRedirect($url);	
	}
	/////////////////////////////Custom fields functions here///
	
	/**
	 * Save field
	 *
	 */
	function save_field() {
		$post = JRequest::get('post' , JREQUEST_ALLOWHTML);
		$model =  $this->getModel('field') ;
		$cid = $post['cid'];
		$post['id'] = (int) $cid[0];
		$ret =  $model->store($post);
		$id = JRequest::getInt('id', 0) ;	
		$task = $this->getTask() ;
		switch ($task) {
			case 'apply_field' :
				$url = 'index.php?option=com_pmform&task=edit_field&cid[]='.$id ;
				break ;
			case 'save2new_field' :
				$url = 'index.php?option=com_pmform&task=add_field';
				$msg = JText::_('Successfully saving field! You can add new field');
				break ;
			default:
				$url = 'index.php?option=com_pmform&view=fields';
				break ;						
		}
		if ($ret) {
			if (!isset($msg))
				$msg = JText::_('Successfully saving field');	
		} else {
			$msg = JText::_('Error while saving field') ;
		}
		$this->setRedirect($url, $msg);
	}
	/**
	 * Remove selected fields
	 *
	 */	
	function remove_fields() {
		$cid = JRequest::getVar('cid', null);
		JArrayHelper::toInteger($cid);
		$model = $this->getModel('field');
		$ret = $model->delete($cid);
		if ($ret) {
			$msg = JText::_('Successfully removing fields'); 
		} else {
			$msg = JText::_('Error while removing fields');
		}
		$this->setRedirect('index.php?option=com_pmform&view=fields', $msg);
	}
	/**
	 * Publish the selected fields
	 *
	 */
	function fields_publish() {
		$cid = JRequest::getVar('cid', null) ;
		JArrayHelper::toInteger($cid);
		$model = $this->getModel('field');
		$ret = $model->publish($cid , 1);
		if ($ret) {
			$msg = JText::_('Fields successfully published'); 
		} else {
			$msg = JText::_('Error while publishing fields');
		}
		$this->setRedirect('index.php?option=com_pmform&view=fields', $msg);
	}
	/**
	 * Unpublish the selected fields
	 *
	 */
	function fields_unpublish() {
		$cid = JRequest::getVar('cid', null) ;
		JArrayHelper::toInteger($cid);
		$model = $this->getModel('field') ;
		$ret =  $model->publish($cid, 0);
		if ($ret) {
			$msg = JText::_('Fields successfully unpublished'); 
		} else {
			$msg = JText::_('Error while unpublishing fields');
		}
		$this->setRedirect('index.php?option=com_pmform&view=fields', $msg);
	}
	/**
	 * Require the selected fields
	 *
	 */
	function required() {
		$cid = JRequest::getVar('cid', null) ;
		JArrayHelper::toInteger($cid);
		$model = $this->getModel('field');
		$ret = $model->required($cid , 1);
		if ($ret) {
			$msg = JText::_('Required status successfully change'); 
		} else {
			$msg = JText::_('Error while changing required status');
		}
		$this->setRedirect('index.php?option=com_pmform&view=fields', $msg);
	}
	
	/**
	 * Change status to un required
	 *
	 */
	function un_required() {
		$cid = JRequest::getVar('cid', null) ;
		JArrayHelper::toInteger($cid);
		$model = $this->getModel('field');
		$ret = $model->required($cid , 0);
		if ($ret) {
			$msg = JText::_('Required status successfully change'); 
		} else {
			$msg = JText::_('Error while changing required status');
		}
		$this->setRedirect('index.php?option=com_pmform&view=fields', $msg);
	}
	/**
	 * Redirect user to fields mangement page
	 *
	 */
	function cancel_field() {
		$this->setRedirect('index.php?option=com_pmform&view=fields');
	}
	
	/**
	 * Save ordering of the selected fields
	 *
	 */
	function save_field_order() {
		$cid = JRequest::getVar('cid', array(), 'post');
		JArrayHelper::toInteger($cid);
		$order = JRequest::getVar('order', array(), 'post');
		JArrayHelper::toInteger($order);
		$model = & $this->getModel('field');
		$ret =  $model->saveOrder($cid, $order);
		if ($ret) 
			$msg =  JText::_('Ordering updated');
		else 
			$msg = JText::_('Error while updating ordering');
		$url = 'index.php?option=com_pmform&view=fields';	
		$this->setRedirect($url, $msg);		
	}
	/**
	 * Orderdown the field
	 *
	 */
	function orderdown_field() {
		$model =  $this->getModel('field');
		$model->move(1);		
		$msg = JText::_('Ordering updated');		
		$url = 'index.php?option=com_pmform&view=fields';
		$this->setRedirect($url, $msg);
	}
	/**
	 * Copy a field
	 *
	 */
	function copy_field() {
		$cid = JRequest::getVar('cid', array(), 'post');
		JArrayHelper::toInteger($cid);
		$model =  $this->getModel('field');
		$id = $model->copy($cid[0]);		
		$msg = JText::_('Field was successfully copied');		
		$url = 'index.php?option=com_pmform&task=edit_field&cid[]='.$id;
		$this->setRedirect($url, $msg);	
	}
	/**
	 * Order up the field
	 *
	 */
	function orderup_field() {
		$model =  $this->getModel('field');
		$model->move(-1);	 				
		$msg = JText::_('Ordering updated');		
		$url = 'index.php?option=com_pmform&view=fields';
		$this->setRedirect($url, $msg);
	}
	/**
	 * Save language translation
	 *
	 */
	function save_translation() {
		$model =  $this->getModel('language');
		$data = JRequest::get('post', JREQUEST_ALLOWHTML) ;
		$model->save($data);
		$lang = $data['lang'] ;
		$item = $data['item'];		
		$url = 'index.php?option=com_pmform&task=translation&lang='.$lang.'&item='.$item;
		$msg = JText::_('Traslation saved') ;
		$this->setRedirect($url, $msg);
	}	
	/**
	 * Save plugin
	 *
	 */
	function save_plugin() {
		$model = & $this->getModel('plugin') ;
		$data = JRequest::get('post') ;
		$ret = $model->store($data);
		if ($ret) {
			$msg = JText::_('Plugin successfully saved') ;		
		} else {
			$msg = JText::_('Error while saving plugin') ;
		}
		$this->setRedirect( 'index.php?option=com_pmform&view=plugins', $msg);
	}	
	/**
	 * Install the plugin
	 *
	 */
	function install_plugin() {
		$model = & $this->getModel('plugin') ;
		$ret = $model->install();
		if ($ret) {
			$msg = JText::_('Plugin installed');
		} else {
			$msg = JRequest::getVar('msg', 'Error installing the plugin') ;
		}
		$this->setRedirect('index.php?option=com_pmform&view=plugins', $msg);		
	}
	/**
	 * Uninstall the selected plugin
	 *
	 */	
	function uninstall_plugin() {
		$model = & $this->getModel('plugin');
		$cid = JRequest::getVar('cid', array(), 'post', 'array') ;
		JArrayHelper::toInteger($cid);
		$ret = $model->uninstall($cid[0]);
		if ($ret) {
			$msg = JText::_('Plugin successfully uninstalled');	
		} else {
			$msg = JRequest::getVar('msg', 'Error uninstalling the plugin') ;
		}
		$this->setRedirect('index.php?option=com_pmform&view=plugins', $msg);		
	}
	/**
	 * Publish selected plugins
	 *
	 */
	function plugins_publish() {
		$model = & $this->getModel('plugin') ;
		$cid = JRequest::getVar('cid', array(), 'post', 'array') ;
		JArrayHelper::toInteger($cid);
		$ret = $model->publish($cid, 1) ;
		if ($ret) {
			$msg =  JText::_('Plugins successfully published');
		} else {
			$msg = JText::_('Error while publishing plugins');
		}
		$this->setRedirect('index.php?option=com_pmform&view=plugins', $msg);
	}
	/**
	 * Unpublish selected plugins
	 *
	 */
	function plugins_unpublish() {
		$model = & $this->getModel('plugin') ;
		$cid = JRequest::getVar('cid', array(), 'post', 'array') ;
		JArrayHelper::toInteger($cid);
		$ret = $model->publish($cid, 0) ;
		if ($ret) {
			$msg =  JText::_('Plugins successfully unpublished');
		} else {
			$msg = JText::_('Error while unpublishing plugins');
		}
		$this->setRedirect('index.php?option=com_pmform&view=plugins', $msg);
	}	
	/**
	 * Save ordering of the selected category
	 *
	 */
	function save_plugin_order() {
		$order = JRequest::getVar('order', array(), 'post') ;
		$cid = JRequest::getVar('cid', array(), 'post') ;
		JArrayHelper::toInteger($order);
		JArrayHelper::toInteger($cid);
		$model = & $this->getModel('plugin');
		$ret = $model->saveOrder($cid, $order);
		if ($ret) {
			$msg = JText::_('Ordering saved') ; 
		} else {
			$msg = JText::_('Error saving ordering') ;
		}
		$this->setRedirect('index.php?option=com_pmform&view=plugins', $msg);
	}
	/**
	 * Order up a category
	 *
	 */
	function orderup_plugin() {
		$model =  $this->getModel('plugin');
		$model->move(-1);		 			
		$msg = JText::_('Ordering updated');			
		$url = 'index.php?option=com_pmform&view=plugins';
		$this->setRedirect($url, $msg);
	}
	/**
	 * Order down a category
	 *
	 */
	function orderdown_plugin() {
		$model =  $this->getModel('plugin');
		$model->move(1);		 			
		$msg = JText::_('Ordering updated');			
		$url = 'index.php?option=com_pmform&view=plugins';
		$this->setRedirect($url, $msg);
	}			
	/**
	 * Redirect to plugin management homepage
	 *
	 */
	function cancel_plugin() {
		$this->setRedirect('index.php?option=com_pmform&view=plugins');
	}
	/**
	 * Download a file
	 *
	 */
	function download_file() {		
		$Itemid = JRequest::getInt('Itemid') ;
		$filePath = PmFormHelper::getConfigValue('path_upload') ;				
		$fileName = JRequest::getVar('file_name', '') ;				
		if (file_exists(JPATH_ROOT.'/'.$filePath.'/'.$fileName)) {
			while (@ob_end_clean());	
			PmFormHelper::processDownload(JPATH_ROOT.'/'.$filePath.'/'.$fileName, $fileName);		
			exit() ;
		} else {
			$mainframe = JFactory::getApplication() ;			
			$mainframe->redirect('index.php?option=com_pmform&Itemid='.$Itemid, JText::_('PF_FILE_NOT_EXIST'));
		}
	}	
	/**
	 * Save coupon
	 *
	 */
	function save_coupon() {
		$post = JRequest::get('post' , JREQUEST_ALLOWHTML);
		$model =  $this->getModel('coupon') ;
		$cid = $post['cid'];
		$post['id'] = (int) $cid[0];
		$ret =  $model->store($post);
		if ($ret) {
			$msg = JText::_('Successfully saving coupon');	
		} else {
			$msg = JText::_('Error while saving coupon') ;
		}
		$this->setRedirect('index.php?option=com_pmform&view=coupons', $msg);
	}
	/**
	 * Remove selected fields
	 *
	 */	
	function remove_coupons() {
		$cid = JRequest::getVar('cid', null);
		JArrayHelper::toInteger($cid);
		$model = $this->getModel('coupon');
		$ret = $model->delete($cid);
		if ($ret) {
			$msg = JText::_('Successfully removing coupons'); 
		} else {
			$msg = JText::_('Error while removing coupons');
		}
		$this->setRedirect('index.php?option=com_pmform&view=coupons', $msg);
	}
	/**
	 * Publish the selected coupons
	 *
	 */
	function coupons_publish() {
		$cid = JRequest::getVar('cid', null) ;
		JArrayHelper::toInteger($cid);
		$model = $this->getModel('coupon');
		$ret = $model->publish($cid , 1);
		if ($ret) {
			$msg =  JText::_('Coupons successfully published');
		} else {
			$msg = JText::_('Error while publishing coupons');
		}
		$this->setRedirect('index.php?option=com_pmform&view=coupons', $msg);
	}
	/**
	 * Unpublish the selected fields
	 *
	 */
	function coupons_unpublish() {
		$cid = JRequest::getVar('cid', null) ;
		JArrayHelper::toInteger($cid);
		$model = $this->getModel('coupon') ;
		$ret =  $model->publish($cid, 0);
		if ($ret) {
			$msg = JText::_('Coupons successfully unpublished'); 
		} else {
			$msg = JText::_('Error while unpublishing coupons');
		}
		$this->setRedirect('index.php?option=com_pmform&view=coupons', $msg);
	}
	/**
	 * Redirect users to coupons page
	 * 
	 */
	function cancel_coupon() {		
		$this->setRedirect('index.php?option=com_pmform&view=coupons') ;			
	}	
	
	function send_massmail() {
		$data = JRequest::get('post', JREQUEST_ALLOWRAW) ;
		$model = & $this->getModel('massmail') ;
		$model->send($data);
		$this->setRedirect('index.php?option=com_pmform&view=massmail', JText::_('Successfully sending emails to payers')) ;
	}
	
	/**
	 * Update database schema... to the latest version
	 *
	 */
	function do_upgrade() {
		require_once JPATH_COMPONENT.'/install.pmform.php';
		com_pmformInstallerScript::updateDatabaseSchema();
	}	
}