<?php
/**
 * @version		3.0
 * @package		Joomla
 * @subpackage	Payment Form
 * @author  Tuan Pham Ngoc
 * @copyright	Copyright (C) 2010 Ossolution Team
 * @license		GNU/GPL, see LICENSE.php
 */
/** ensure this file is being included by a parent file */
defined( '_JEXEC' ) or die( 'Direct Access to this location is not allowed.' );
/**
 * Change the db structure of the previous version
 *
 */

class com_pmformInstallerScript {
	/**
	 * method to install the component
	 *
	 * @return void
	 */
	function install($parent)
	{
		$this->updateDatabaseSchema() ;
	}
	
	function update($parent)
	{
		$this->updateDatabaseSchema() ;
	}
	
	function updateDatabaseSchema() {
		jimport('joomla.filesystem.folder') ;
		jimport('joomla.filesystem.file') ;
		require_once JPATH_ROOT.'/components/com_pmform/helper/helper.php';
		$j3 = version_compare(JVERSION, '1.6.0', 'ge') ? true : false ;
	 	$db = & JFactory::getDBO();	
		//Load config config data	
		$sql = 'SELECT COUNT(*) FROM #__pf_configs';
		$db->setQuery($sql) ;
		$total = $db->loadResult();
		if (!$total) {		
			$configSql = JPATH_ADMINISTRATOR.'/components/com_pmform/sql/config.pmform.sql' ;
			$sql = JFile::read($configSql) ;
			$queries = $db->splitSql($sql);
			if (count($queries)) {
				foreach ($queries as $query) {
				if ($query != '' && $query{0} != '#') {
						$db->setQuery($query);
						$db->query();						
					}	
				}
			}
			
			//Update date_format config option
		    if (version_compare(JVERSION, '1.6.0', 'ge')) {
			    $sql = 'UPDATE #__pf_configs SET config_value="m-d-Y" WHERE config_key="date_format"';
			    $db->setQuery($sql) ;
			    $db->query();    
			}				
		}
		//Version 1.1 : Add fields to form
		$sql = ' SHOW FIELDS FROM #__pf_forms ';
		$db->setQuery($sql);
		$rows = $db->loadObjectList();
		$fields = array();
		for ($i = 0 , $n = count($rows); $i < $n; $i++) {
			$row = $rows[$i];
			$fields[] = $row->Field; 				
		}
		if (!in_array('access', $fields)) {
			$sql = "ALTER TABLE `#__pf_forms` ADD `access` TINYINT NOT NULL DEFAULT '0'";
			$db->setQuery($sql);
			$db->query();
		}
		if (!in_array('enter_amount', $fields)) {
			$sql = "ALTER TABLE `#__pf_forms` ADD `enter_amount` TINYINT NOT NULL DEFAULT '0'";
			$db->setQuery($sql);
			$db->query();
		}
		if (!in_array('fee_calculation_script', $fields)) {
			$sql = "ALTER TABLE `#__pf_forms` ADD `fee_calculation_script` TEXT NULL AFTER  `enter_amount`";
			$db->setQuery($sql);
			$db->query();
		}			
		//Version 1.2 : Add some extra veriables	
		if (!in_array('form_layout', $fields)) {
			$sql = "ALTER TABLE `#__pf_forms` ADD `form_layout` VARCHAR( 50 ) NULL ;";
			$db->setQuery($sql);
			$db->query();
		}			
		//Added attachment support from version 1.7.0
		if (!in_array('attachment', $fields)) {
		    $sql = "ALTER TABLE  `#__pf_forms` ADD  `attachment` VARCHAR( 255 ) NULL;";
			$db->setQuery($sql);
			$db->query();
					
			//Need to create com_eventbooking folder under media folder
					
			if (!JFolder::exists(JPATH_ROOT.'/media/com_pmform')) {
			    JFolder::create(JPATH_ROOT.'/media/com_pmform');
			}			
		}
	    //Version 2.1, coupon code support
	    if (!in_array('enable_coupon', $fields)) {
			$sql = "ALTER TABLE `#__pf_forms` ADD `enable_coupon` TINYINT NOT NULL DEFAULT '0'";
			$db->setQuery($sql);
			$db->query();
		}	
		//Version 2.2, payment methods selection
		if (!in_array('payment_methods', $fields)) {
			$sql = "ALTER TABLE `#__pf_forms` ADD `payment_methods` VARCHAR( 255 ) NULL;";
			$db->setQuery($sql);
			$db->query();
		}
		
	    $sql = ' SHOW FIELDS FROM #__pf_payments ';
		$db->setQuery($sql);
		$rows = $db->loadObjectList();
		$fields = array();
		for ($i = 0 , $n = count($rows); $i < $n; $i++) {
			$row = $rows[$i];
			$fields[] = $row->Field; 				
		}
	    if (!in_array('discount_amount', $fields)) {
			$sql = "ALTER TABLE  `#__pf_payments` ADD  `discount_amount` DECIMAL( 10, 2 ) NULL DEFAULT '0' ;";
			$db->setQuery($sql);
			$db->query();
		}
		
		if (!in_array('coupon_id', $fields)) {
			$sql = "ALTER TABLE  `#__pf_payments` ADD  `coupon_id` INT NOT NULL DEFAULT '0' ;";
			$db->setQuery($sql);
			$db->query();
		}
		
		//Change data type of description field to allows longer text
		
		$sql = 'ALTER TABLE `#__pf_fields` CHANGE  `description`  `description` TEXT NULL;';
		$db->setQuery($sql);
		$db->query();
				
		$sql = ' SHOW FIELDS FROM #__pf_fields ';
		$db->setQuery($sql);
		$rows = $db->loadObjectList();
		$fields = array();
		for ($i = 0 , $n = count($rows); $i < $n; $i++) {
			$row = $rows[$i];
			$fields[] = $row->Field; 				
		}
			
		if (!in_array('datatype_validation', $fields)) {
			$sql = "ALTER TABLE `#__pf_fields` ADD `datatype_validation` TINYINT NOT NULL DEFAULT '0' ";
			$db->setQuery($sql);
			$db->query();
		}
		
		if (!in_array('fee_formula', $fields)) {
			$sql = "ALTER TABLE `#__pf_fields` ADD `fee_formula` VARCHAR( 250 ) NULL ";
			$db->setQuery($sql);
			$db->query();
		}	
		
		if (!in_array('field_mapping', $fields)) {
			$sql = "ALTER TABLE `#__pf_fields` ADD `field_mapping` VARCHAR( 50 ) NULL ";
			$db->setQuery($sql);
			$db->query();
		}	
		
		if (!in_array('is_core', $fields)) {
			$sql = "ALTER TABLE `#__pf_fields` ADD `is_core` TINYINT NOT NULL DEFAULT '0' ";
			$db->setQuery($sql);
			$db->query();
		}
				
		//We will need to insert core field
		$sql = 'SELECT COUNT(*) FROM #__pf_fields WHERE is_core = 1';
		$db->setQuery($sql) ;
		$total = $db->loadResult();
		if (!$total) {
			$sql = 'SELECT * FROM #__pf_fields ORDER BY id DESC ';
			$db->setQuery($sql) ;
			$rows = $db->loadObjectList();
			for ($i = 0 , $n = count($rows) ; $i < $n ; $i++) {
				$row = $rows[$i] ;
				$sql = 'UPDATE #__pf_fields SET id = id + 14 WHERE id='.$row->id;
				$db->setQuery($sql) ;
				$db->query();	
			}		
			//Update total custom field
			$sql = 'UPDATE #__pf_fields SET id = id + 14' ; 
			$db->setQuery($sql);
			$db->query();
									
			$sql = 'SELECT id FROM #__pf_forms';
			$db->setQuery($sql) ;
			if ($j3) {
				$formIds = $db->loadColumn();
			} else {
				$formIds = $db->loadResultArray();
			}
			
			
			$sql = 'SELECT id FROM #__pf_fields WHERE form_id=0';
			$db->setQuery($sql) ;
			if ($j3) {
				$fieldIds = $db->loadColumn();
			} else {
				$fieldIds = $db->loadResultArray();
			}			
			if (count($fieldIds)) {
				foreach ($fieldIds as $fieldId) {
					for ($i = 0 , $n = count($formIds) ; $i < $n ; $i++) {
						$formId = $formIds[$i] ;
						$sql = 'INSERT INTO #__pf_form_fields(form_id, field_id) VALUES('.$formId.','.$fieldId.')';
						$db->setQuery($sql) ;
						$db->query();	
					}
				}
			}
			$sql = 'SELECT id, form_id FROM #__pf_fields WHERE form_id > 0';
			$db->setQuery($sql) ;
			$fields = $db->loadObjectList();
			if (count($fields)) {
				foreach ($fields as $field) {
					$fieldId = $field->id ;				
					$formId = $field->form_id ;
					$sql = 'INSERT INTO #__pf_form_fields(form_id, field_id) VALUES('.$formId.','.$fieldId.')';
					$db->setQuery($sql) ;
					$db->query();					
				}
			}				
			//Update the auto increament value
			$prefix = $db->getPrefix();
			$sql = "SHOW TABLE STATUS LIKE  '#__pf_fields'";
			$sql = str_replace('#__', $prefix, $sql);
			$db->setQuery($sql) ;
			$row = $db->loadObject();
			$autoIncreament = (int)$row->Auto_increment ;
			$autoIncreament += 14 ;		
			$sql = 'ALTER TABLE #__pf_fields AUTO_INCREMENT = '.$autoIncreament ;
			$db->setQuery($sql) ;
			$db->query();
			//Insert core fields into database
			$coreFieldsSql = JPATH_ADMINISTRATOR.'/components/com_pmform/sql/core_fields.pmform.sql' ;
			$sql = JFile::read($coreFieldsSql) ;
			$queries = $db->splitSql($sql);
			if (count($queries)) {
				foreach ($queries as $query) {
				$query = trim($query);
				if ($query != '' && $query{0} != '#') {
						$db->setQuery($query);
						$db->query();						
					}	
				}
			}
			//Path upload		
			$pathUpload = PmFormHelper::getConfigValue('path_upload') ;
			if (!$pathUpload) {
				$pathUpload = 'images/com_pmform' ;
				PmFormHelper::saveConfigValue('path_upload', $pathUpload); 			
			}
			if (!JFolder::exists(JPATH_ROOT.'/'.$pathUpload)) {
				JFolder::create(JPATH_ROOT.'/'.$pathUpload) ;
			}
			if (!JFile::exists(JPATH_ROOT.'/'.$pathUpload.'/.htaccess')) {
				JFile::copy(JPATH_ROOT.'/administrator/components/com_pmform/htaccess.txt', JPATH_ROOT.'/'.$pathUpload.'/.htaccess') ;
			}
		}				
		//Update show that all core fields are assigned to all forms by default
		$sql = 'UPDATE #__pf_fields SET form_id=-1 WHERE is_core=1';
		$db->setQuery($sql) ;
		$db->query();
		
		//Need to check and generate data for plugins table
		$sql = 'SELECT COUNT(*) FROM #__pf_payment_plugins';
		$db->setQuery($sql) ;
		$total = $db->loadResult();
		if (!$total) {
			$configSql = JPATH_ADMINISTRATOR.'/components/com_pmform/sql/plugins.pmform.sql' ;
			$sql = JFile::read($configSql) ;
			$queries = $db->splitSql($sql);
			if (count($queries)) {
				foreach ($queries as $query) {
				$query = trim($query);
				if ($query != '' && $query{0} != '#') {
						$db->setQuery($query);
						$db->query();						
					}	
				}
			}		
			//Set up parameter for default payment gateway
			$config = PmFormHelper::getConfig() ;
			if(isset($config->paypal_id)) {
				//Paypal		
				$txt = array() ;				
				$txt[] = 'paypal_id='.$config->paypal_id ;
				$txt[] = 'paypal_mode='.$config->paypal_mode ;
				$txt[] = 'paypal_currency='.$config->paypal_currency;
				$txt = implode("\n", $txt) ;
				$sql = 'UPDATE  #__eb_payment_plugins SET params='.$db->Quote($txt).' WHERE name="os_paypal"';
				$db->setQuery($sql) ;
				$db->query();
				//Authorize.net
				$txt = array() ;				
				$txt[] = 'authnet_mode='.$config->authnet_mode ;
				$txt[] = 'x_login='.$config->x_login ;
				$txt[] = 'x_tran_key='.$config->x_tran_key ;
				$txt = implode("\n", $txt) ;
				$sql = 'UPDATE  #__eb_payment_plugins SET params='.$db->Quote($txt).' WHERE name="os_authnet"';
				$db->setQuery($sql) ;
				$db->query();
				//Eway
				$txt = array() ;				
				$txt[] = 'eway_mode='.$config->eway_mode ;
				$txt[] = 'eway_customer_id='.$config->eway_customer_id ;		
				$txt[] = 'use_cvn='.$config->use_cvn ;		
				$txt = implode("\n", $txt) ;
				$sql = 'UPDATE  #__eb_payment_plugins SET params='.$db->Quote($txt).' WHERE name="os_eway"';
				$db->setQuery($sql) ;
				$db->query();			
			}		
		}
			
	    #Update form fields table			
	    $sql = ' SHOW FIELDS FROM #__pf_form_fields ';
		$db->setQuery($sql);
		$rows = $db->loadObjectList();
		$fields = array();
		for ($i = 0 , $n = count($rows); $i < $n; $i++) {
			$row = $rows[$i];
			$fields[] = $row->Field; 				
		}
		
		//Update database schecme of fields setting for each form
		$updateData = false ;
	    if (!in_array('required', $fields)) {
			$sql = "ALTER TABLE `#__pf_form_fields` ADD `required` TINYINT NOT NULL DEFAULT '0' ";
			$db->setQuery($sql);
			$db->query();	
			$updateData = true ;	
		}
		
	    if (!in_array('published', $fields)) {
			$sql = "ALTER TABLE `#__pf_form_fields` ADD `published` TINYINT NOT NULL DEFAULT '0' ";
			$db->setQuery($sql);
			$db->query();
			$updateData = true ;
		}
		
	    if (!in_array('ordering', $fields)) {
			$sql = "ALTER TABLE `#__pf_form_fields` ADD `ordering` INT NOT NULL DEFAULT '0' ";
			$db->setQuery($sql);
			$db->query();
			$updateData = true ;
		}		
		$j16 = version_compare(JVERSION, '1.6.0', 'ge') ? true : false ;			
		if ($updateData) {
		    //Get all forms currently in the system, and perform setting up
		    $sql = 'SELECT id, `params`, enter_amount FROM #__pf_forms';
		    $db->setQuery($sql) ;
		    $rowForms = $db->loadObjectList() ;
		    for ($i = 0 , $n = count($rowForms) ; $i < $n ; $i++) {
		         $rowForm = $rowForms[$i] ;
		         if ($j16)
		             $params = new JRegistry($rowForm->params) ;
		         else 
		             $params = new JParameter($rowForm->params) ;    
		         //Get all fields belong to this form
		         $sql = "SELECT a.id, a.name, a.required, a.ordering, a.published, a.is_core FROM #__pf_fields AS a WHERE a.form_id=-1 OR a.id IN (SELECT field_id FROM #__pf_form_fields WHERE form_id=$rowForm->id) ORDER BY a.ordering";
		         $db->setQuery($sql) ;
		         $rowFields = $db->loadObjectList() ;
		         $ordering = 0 ;	         	         
		         //Delete data from the table
		         $sql = 'DELETE FROM #__pf_form_fields WHERE form_id='.$rowForm->id;
		         $db->setQuery($sql) ;
		         $db->query();
		         
		         if (count($rowFields)) {
		             foreach ($rowFields as $rowField) {
		                 $ordering++ ;
		                 if ($rowField->is_core) {
		                     $required = 0 ;
		                     $published = 0 ;	                 ;
	        				 if ($rowField->name == 'first_name' || $rowField->name == 'email') {
	        				     $published = 1 ;
	        					 $required = 1 ;        																					
	        				 } elseif ($rowField->name == 'last_name') {
	        					 if ($params->get('s_lastname', 1)) {
	        					    $published = 1 ;
	        						if ($params->get('r_lastname', 1))
	        							 $required = 1 ;        							
	        						}					
	        				 } elseif ($rowField->name == 'amount') {        				     
	        						if ($rowForm->enter_amount) {
	        						    $published = 1 ;
	        							$required = 1 ;        											
	        						}
	        				 }else {
	        						if ($params->get('s_'.$rowField->name, 1)) {
	        						    $published = 1 ;
	        							if ($params->get('r_'.$rowField->name, 1))
	        								$required = 1 ;							        							
	        						}						
	        				 }        				 
		                 } else {
		                     $published = 1 ;
		                     $required = $rowField->required ;
		                 }
		                 $sql = "INSERT INTO #__pf_form_fields(form_id, field_id, required, ordering, published) VALUES($rowForm->id, $rowField->id, $required, $ordering, $published)";
		                 $db->setQuery($sql) ;
		                 $db->query();
		             }
		         }   
		    }	    
		}	
	}
}