<?php
/**
 * @version		3.0
 * @package		Joomla
 * @subpackage	Payment Form
 * @author  Tuan Pham Ngoc
 * @copyright	Copyright (C) 2010 Ossolution Team
 * @license		GNU/GPL, see LICENSE.php
 */
// Check to ensure this file is included in Joomla!
defined('_JEXEC') or die ;

/**
 * Payment Form Component Configuration Model
 *
 * @package		Joomla
 * @subpackage	Payment Form
 * @since 1.5
 */
class PmFormModelConfiguration extends JModelLegacy
{
	/**
	 * Containing all config data,  store in an object with key, value
	 *
	 * @var object
	 */
	var $_data = null;
	
	function __construct() {
		parent::__construct();
	}
	
	/**
	 * Get configuration data
	 *
	 */
	function getData() {
		if (empty($this->_data)) {
			$config = new stdClass ;
			$sql = 'SELECT config_key, config_value FROM #__pf_configs';
			$this->_db->setQuery($sql);
			$rows = $this->_db->loadObjectList();
			if (count($rows)) {
				for ($i = 0, $n = count($rows); $i < $n; $i++) {
					$row = $rows[$i];
					$key = $row->config_key;
					$value = $row->config_value;
					$config->$key = stripslashes($value);						
				}	
			} else {
				//Init default values for config variables
				$config->cb_integration = 0;
				$config->use_campaign = 1; 
				$config->minimum_donation_amount = '';
				$config->show_campaign_title = 1;
				$config->show_campaign_start_date = 1;
				$config->show_campaign_end_date = 1;
				$config->show_campaign_goal =  1;
				$config->show_campaign_donated_amount = 1;
				$config->payment_methods = '';
				$config->currency_symbol = '';
				$config->default_country = '';
				$config->donation_amounts = '';
				$config->admin_email_subject = '';
				$config->admin_email_body = '';
				$config->user_email_subject = '';
				$config->user_email_body = '';
				$config->notification_emails = '';
				$config->confirmation_message = '';
				$config->thanks_message = '';
				$config->cancel_message = '';
				$config->paypal_id = '';
				$config->paypal_mode = 1;
				$config->paypal_currency = '';
				$config->mb_merchant_email = '';
				$config->mb_merchant_id = '';
				$config->mb_secret_word = '';
				$config->mb_currency = '';
				$config->authnet_mode = 0;
				$config->x_login = '';
				$config->x_tran_key = '';
				$config->s_username = 0;
				$config->r_username = 0 ;
				$config->s_name = 0;
				$config->r_name = 0 ;				
				$config->s_first_name = 1;
				$config->r_first_name = 1 ;
				$config->s_last_name = 1;
				$config->r_last_name = 1 ;
				$config->s_organization = 1;
				$config->r_organization = 1;
				$config->s_address = 1;
				$config->r_address = 1;
				$config->s_city =  1;
				$config->r_city = 1;
				$config->s_state = 1 ;
				$config->r_state = 1 ;
				$config->s_zip = 1 ;
				$config->r_zip = 1 ;
				$config->s_country = 1;
				$config->r_country =  1;
				$config->s_phone = 1;
				$config->r_phone = 1;
				$config->s_comment = 1;
				$config->r_comment = 1;	
				//CB fields mapping
				$config->m_firstname = 'firstname';
				$config->m_lastname = 'lastname';
				$config->m_organization = 'company';
				$config->m_address = 'address';
				$config->m_city = 'city';
				$config->m_state = 'state';
				$config->m_zip = 'zipcode';
				$config->m_country = 'country';
				$config->m_phone = 'phone';				 																																
			}
			$this->_data = $config;		
		}			
		return $this->_data ;
	}
	/**
	 * Store the configuration data
	 *
	 * @param array $post
	 */
	function store($data) {
		jimport('joomla.filesystem.folder') ;
		jimport('joomla.filesystem.file') ;
		$sql = 'TRUNCATE TABLE #__pf_configs';
		$this->_db->setQuery($sql);
		$this->_db->query();
		foreach ($data as $key=>$value) {
			$configKey = $this->_db->Quote($key);
			$configValue = $this->_db->Quote($value);
			$sql = 'INSERT INTO #__pf_configs(config_key, config_value) VALUES('.$configKey.','.$configValue.')';			
			$this->_db->setQuery($sql);
			if (!$this->_db->query())
				return false;			
		}		
		$pathUpload = PmFormHelper::getConfigValue('path_upload') ;
		if ($pathUpload) {
			if (!JFolder::exists(JPATH_ROOT.'/'.$pathUpload)) {
				JFolder::create(JPATH_ROOT.'/'.$pathUpload) ;
			}
			if (!JFile::exists(JPATH_ROOT.'/'.$pathUpload.'/.htaccess')) {
				JFile::copy(JPATH_COMPONENT.'/'.'htaccess.txt', JPATH_ROOT.'/'.$pathUpload.'/.htaccess') ;
			}	
		}		
		return true;
	}
}