<?php
/**
 * @version		3.0
 * @package		Joomla
 * @subpackage	Payment Form
 * @author  Tuan Pham Ngoc
 * @copyright	Copyright (C) 2010 Ossolution Team
 * @license		GNU/GPL, see LICENSE.php
 */
defined('_JEXEC') or die();

/**
* Payment table class
*
* @package		Joomla
* @subpackage	Payment Form
* @since 1.5
*/
class PaymentPmForm extends JTable
{

	/**
	 * Constructor
	 *
	 * @param object Database connector object
	 * @since 1.5
	 */
	function __construct(& $db)
	{
		parent::__construct('#__pf_payments', 'id', $db);
	}
}

/**
* Form table class
*
* @package		Joomla
* @subpackage	Payment Form
* @since 1.5
*/
class FormPmForm extends JTable
{

	/**
	 * Constructor
	 *
	 * @param object Database connector object
	 * @since 1.5
	 */
	function __construct(& $db)
	{
		parent::__construct('#__pf_forms', 'id', $db);
	}
}

/**
 * Field table class
 *
 */
class FieldPmForm extends JTable
{

	/**
	 * Constructor
	 *
	 * @param object Database connector object
	 * @since 1.5
	 */
	function __construct(& $db)
	{
		parent::__construct('#__pf_fields', 'id', $db);
	}
}

/**
 * Plugin table class
 *
 */
class PluginPmForm extends JTable
{

	/**
	 * Constructor
	 *
	 * @param object Database connector object
	 * @since 1.5
	 */
	function __construct(& $db)
	{
		parent::__construct('#__pf_payment_plugins', 'id', $db);
	}
}

/**
 * Coupon Table
 *
 */
class CouponPmForm extends JTable
{

	/**
	 * Constructor
	 *
	 * @param object Database connector object
	 * @since 1.5
	 */
	function __construct(& $db)
	{
		parent::__construct('#__pf_coupons', 'id', $db);
	}
}

/**
 * Field Values
 *
 */
class FieldValuePmForm extends JTable
{

	/**
	 * Constructor
	 *
	 * @param object Database connector object
	 * @since 1.5
	 */
	function __construct(& $db)
	{
		parent::__construct('#__pf_field_value', 'id', $db);
	}
}