<?php
/**
 * @version		1.4.2
 * @package		Joomla
 * @subpackage	Payment Form
 * @author  Tuan Pham Ngoc
 * @copyright	Copyright (C) 2010 Ossolution Team
 * @license		GNU/GPL, see LICENSE.php
 */
// no direct access
defined( '_JEXEC' ) or die ;

// Set toolbar items for the page
JToolBarHelper::title(JText::_( 'Coupon Management' ), 'generic.png' );
JToolBarHelper::deleteList(JText::_('Do you want to remove the selected coupons?') , 'remove_coupons');
JToolBarHelper::editList('edit_coupon');	
JToolBarHelper::addNew('add_coupon');
JToolBarHelper::publishList('coupons_publish');
JToolBarHelper::unpublishList('coupons_unpublish');
JHTML::_('behavior.tooltip'); 							
?>
<form action="index.php?option=com_pmform&view=coupons" method="post" name="adminForm" id="adminForm">
<table>
<tr>
	<td align="left" width="100%">
		<?php echo JText::_( 'Filter' ); ?>:
		<input type="text" name="search" id="search" value="<?php echo $this->lists['search'];?>" class="text_area search-query" onchange="document.adminForm.submit();" />		
		<button onclick="this.form.submit();" class="btn"><?php echo JText::_( 'Go' ); ?></button>
		<button onclick="document.getElementById('search').value='';this.form.submit();" class="btn"><?php echo JText::_( 'Reset' ); ?></button>		
	</td>	
</tr>
</table>
<div id="editcell">
	<table class="adminlist">
	<thead>
		<tr>
			<th width="5">
				<?php echo JText::_( 'NUM' ); ?>
			</th>
			<th width="20">
				<input type="checkbox" name="toggle" value="" onclick="Joomla.checkAll(this);" />
			</th>
			<th class="title" style="text-align: left;">
				<?php echo JHTML::_('grid.sort',  JText::_('code'), 'a.code', $this->lists['order_Dir'], $this->lists['order'] ); ?>
			</th>								
			<th width="15%" class="title" nowrap="nowrap">
				<?php echo JText::_('Discount'); ?>
			</th>									
			<th width="10%" class="title" nowrap="nowrap">
				<?php echo JHTML::_('grid.sort',  JText::_('Times'), 'a.times', $this->lists['order_Dir'], $this->lists['order'] ); ?>
			</th>
			<th width="10%" class="title" nowrap="nowrap">
				<?php echo JHTML::_('grid.sort',  JText::_('Used'), 'a.used', $this->lists['order_Dir'], $this->lists['order'] ); ?>
			</th>	
			<th width="10%" class="title" nowrap="nowrap">
				<?php echo JHTML::_('grid.sort',  JText::_('Valid from'), 'a.valid_from', $this->lists['order_Dir'], $this->lists['order'] ); ?>
			</th>					
			<th width="10%" class="title" nowrap="nowrap">
				<?php echo JHTML::_('grid.sort',  JText::_('Valid to'), 'a.valid_to', $this->lists['order_Dir'], $this->lists['order'] ); ?>
			</th>
			<th width="5%" class="title" nowrap="nowrap">
				<?php echo JHTML::_('grid.sort',  JText::_('Published'), 'a.published', $this->lists['order_Dir'], $this->lists['order'] ); ?>
			</th>																
		</tr>
	</thead>
	<tfoot>
		<tr>
			<td colspan="9">
				<?php echo $this->pagination->getListFooter(); ?>
			</td>
		</tr>
	</tfoot>
	<tbody>
	<?php
	$k = 0;
	if (version_compare(JVERSION, '1.6.0', 'ge'))
	    $param = null ;
	else
	    $param = 0 ;
	for ($i=0, $n=count( $this->items ); $i < $n; $i++)
	{
		$row = &$this->items[$i];
		$link 	= JRoute::_( 'index.php?option=com_pmform&task=edit_coupon&cid[]='. $row->id );
		$checked 	= JHTML::_('grid.id',   $i, $row->id );				
		$published 	= JHTML::_('grid.published', $row, $i, 'tick.png', 'publish_x.png', 'coupons_' );			
		?>
		<tr class="<?php echo "row$k"; ?>">
			<td>
				<?php echo $this->pagination->getRowOffset( $i ); ?>
			</td>
			<td>
				<?php echo $checked; ?>
			</td>	
			<td>
				<a href="<?php echo $link; ?>">
					<?php echo $row->code; ?>
				</a>
			</td>
			<td class="center">
				<?php echo number_format($row->discount, 2).$this->discountTypes[$row->coupon_type]  ;?>
			</td>										
			<td class="center">
				<?php echo $row->times; ?>
			</td>	
			<td class="center">
				<?php echo $row->used; ?>
			</td>
			<td class="center">
				<?php
					if ($row->valid_from != $this->nullDate) {
						echo JHTML::_('date', $row->valid_from, $this->dateFormat, $param);
					}
				?>
			</td>	
			<td class="center">
				<?php
					if ($row->valid_to != $this->nullDate) {
						echo JHTML::_('date', $row->valid_to, $this->dateFormat, $param);
					}
				?>
			</td>										
			<td class="center">
				<?php echo $published; ?>
			</td>			
		</tr>
		<?php
		$k = 1 - $k;
	}
	?>
	</tbody>
	</table>
	</div>
	<input type="hidden" name="option" value="com_pmform" />
	<input type="hidden" name="task" value="show_coupons" />
	<input type="hidden" name="boxchecked" value="0" />
	<input type="hidden" name="filter_order" value="<?php echo $this->lists['order']; ?>" />
	<input type="hidden" name="filter_order_Dir" value="<?php echo $this->lists['order_Dir']; ?>" />	
	<?php echo JHTML::_( 'form.token' ); ?>			
</form>