<?php
/**
 * @version		3.0
 * @package		Joomla
 * @subpackage	Payment Form
 * @author  Tuan Pham Ngoc
 * @copyright	Copyright (C) 2010 Ossolution Team
 * @license		GNU/GPL, see LICENSE.php
 */
// Check to ensure this file is included in Joomla!
defined('_JEXEC') or die ;
/**
 * HTML View class for Payment Form component
 *
 * @static
 * @package		Joomla
 * @subpackage	Payment Form
 * @since 1.5
 */
class PmFormViewField extends JViewLegacy
{
	function display($tpl = null)
	{			
		$db = JFactory::getDBO();
		$item = $this->get('Data');
		$fieldTypes = array(
		0 => 'Textbox' ,
		1 => 'Textarea' ,
		2 => 'Dropdown' ,
		3 => 'Checkbox List' ,
		4 => 'Radio List' ,
		5 => 'Date Time',
		6 => 'Heading',		
		7 => 'Message',
		8 => 'MultiSelect',
		9 => 'File Upload'				
		);		
		$options = array() ;
		$options[] = JHTML::_('select.option', -1, JText::_('Field Type')) ;
		foreach ($fieldTypes As $value => $text) {			
			$options[] = JHTML::_('select.option', $value, $text ) ;	
		}					
		if ($item->is_core)
			$readOnly = ' readonly="true" ' ;
		else 
			$readOnly = '';	
		$lists['field_type'] = JHTML::_('select.genericlist', $options, 'field_type',' class="inputbox" '.$readOnly, 'value', 'text', $item->field_type);
		$options = array() ;
		$options[] = JHTML::_('select.option', -1, JText::_('All Forms'), 'id', 'title') ;
		$sql = 'SELECT id, title FROM #__pf_forms WHERE published=1';
		$db->setQuery($sql) ;
		$options = array_merge($options, $db->loadObjectList()) ;				
		$selecteds = array() ;
		if ($item->id) {
			if ($item->form_id == -1) {
				$selecteds[] = JHTML::_('select.option', -1, -1, 'id', 'title');
			} else {
				$sql = 'SELECT form_id FROM #__pf_form_fields WHERE field_id='.$item->id ;
				$db->setQuery($sql) ;
				$rowFields = $db->loadObjectList();
				for ($i = 0 , $n = count($rowFields) ; $i < $n ; $i++) {
					$rowField = $rowFields[$i] ;
					$selecteds[] = JHTML::_('select.option', $rowField->form_id, $rowField->form_id, 'id', 'title');
				}
			}				
		}		
		$lists['form_id'] = JHTML::_('select.genericlist', $options, 'form_id[]', 'class="inputbox" multiple="multiple" size="5" ', 'id', 'title', $selecteds) ;								
		$lists['required'] = JHTML::_('select.booleanlist', 'required', ' class="inputbox" ', $item->required) ;
		$lists['published'] = JHTML::_('select.booleanlist', 'published', ' class="inputbox" ', $item->published) ;
		$lists['fee_field'] = JHTML::_('select.booleanlist', 'fee_field', ' class="inputbox" ', $item->fee_field) ;		
		$options = array() ;
		$options[] = JHTML::_('select.option', 0, JText::_('None')) ;
		$options[] = JHTML::_('select.option', 1, JText::_('Integer Number')) ;
		$options[] = JHTML::_('select.option', 2, JText::_('Number')) ;
		$options[] = JHTML::_('select.option', 3, JText::_('Email')) ;
		$lists['datatype_validation'] = JHTML::_('select.genericlist', $options, 'datatype_validation', 'class="inputbox"', 'value', 'text', $item->datatype_validation) ;
		$integration = PmFormHelper::getConfigValue('cb_integration') ;
		if ($integration > 0) {
			if ($integration == 1) {
				$sql = 'SELECT name AS `value`, name AS `text` FROM #__comprofiler_fields WHERE `table`="#__comprofiler"';	
			} elseif ($integration == 2) {
				$sql = 'SELECT fieldcode AS `value`, fieldcode AS `text` FROM #__community_fields WHERE published=1 AND fieldcode != ""' ;				
			}
			$db->setQuery($sql) ;		
			$options = array() ;
			$options[] = JHTML::_('select.option', '', JText::_('Select Field')) ;
			$options = array_merge($options, $db->loadObjectList()) ;
			$lists['field_mapping'] = JHTML::_('select.genericlist', $options, 'field_mapping', ' class="inputbox" ', 'value', 'text', $item->field_mapping) ;	
		}			
		$this->assignRef('item', $item);				
		$this->assignRef('integration', $integration) ;
		$this->assignRef('lists', $lists );		
		parent::display($tpl);				
	}
}