<?php
/**
 * @version		3.0
 * @package		Joomla
 * @subpackage	Payment Form
 * @author  Tuan Pham Ngoc
 * @copyright	Copyright (C) 2010 Ossolution Team
 * @license		GNU/GPL, see LICENSE.php
 */
// Check to ensure this file is included in Joomla!
defined('_JEXEC') or die ;
/**
 * HTML View class for Payment Form component
 *
 * @static
 * @package		Joomla
 * @subpackage	Payment Form
 * @since 1.5
 */
class PmFormViewForm extends JViewLegacy
{
	function display($tpl = null)
	{				
	    $config = PmFormHelper::getConfig();
		$db = JFactory::getDBO() ;
		$nullDate = $db->getNullDate();
		$item = $this->get('Data');
		if (version_compare(JVERSION, '1.6.0', 'ge')) {
		    $dateFormat = 'Y-m-d' ;
		    $param      = null ;   
		} else {
		    $dateFormat = '%Y-%m-%d' ;
		    $param      = 0 ;  
		}
					
		//Change format of datetime field
		if ($item->publish_up && $item->publish_up != $nullDate) {
			$item->publish_up = JHTML::_('date', $item->publish_up, $dateFormat, $param) ;
		} else {
			$item->publish_up = '';
		}
		
		if ($item->publish_down && $item->publish_down != $nullDate) {
			$item->publish_down = JHTML::_('date', $item->publish_down, $dateFormat, $param) ;
		} else {
			$item->publish_down = '';
		}
		
		if ($item->late_payment_date && $item->late_payment_date != $nullDate) {
			$item->late_payment_date = JHTML::_('date', $item->late_payment_date, $dateFormat, $param) ;
		} else {
			$item->late_payment_date = '';
		}				
		$options = array() ;
		$options[] = JHTML::_('select.option', 0, JText::_('Percent')) ;
		$options[] = JHTML::_('select.option', 1, JText::_('Fixed Amount')) ;
		$lists['late_amount_type'] = JHTML::_('select.genericlist', $options, 'late_amount_type', ' class="inputbox"', 'value', 'text', $item->late_amount_type) ;					
		//Access permission	
		if (version_compare(JVERSION, '1.6.0', 'ge')) {
		    $lists['access'] = JHtml::_('access.level', 'access', $item->access, 'class="inputbox"', false) ;
		} else {
		    $sql = 'SELECT id, name FROM #__groups ';
		    $db->setQuery($sql) ;
		    $lists['access'] = JHTML::_('select.genericlist', $db->loadObjectList(), 'access', 'class="inputbox"', 'id', 'name', $item->access) ;
		}
		
		if ($config->enable_payment_method_selection) {
			//Get list of available payment methods
			$options = array() ;
			$options[] = JHTML::_('select.option', '', JText::_('All Payment Methods'), 'id', 'title');
			$sql = 'SELECT id, title FROM #__pf_payment_plugins WHERE published = 1';
			$db->setQuery($sql);
			$lists['payment_methods'] = JHTML::_('select.genericlist', array_merge($options, $db->loadObjectList()), 'payment_methods[]', ' class="inputbox" multiple="multiple" ', 'id', 'title', explode(',', $item->payment_methods)) ;
		}					
				
		$fields = $this->get('fields');		
		$lists['enable_coupon'] = JHTML::_('select.booleanlist', 'enable_coupon', ' class="inputbox" ', $item->enable_coupon) ;			
		$lists['enter_amount'] = JHTML::_('select.booleanlist', 'enter_amount', ' class="inputbox" ', $item->enter_amount) ;		
		$lists['attachment'] = PmFormHelper::attachmentList($item->attachment, $config);				
		$lists['published'] = JHTML::_('select.booleanlist', 'published', ' class="inputbox" ', $item->published) ;					
							
		$this->assignRef('item', $item);
		$this->assignRef('lists', $lists) ;			
		$this->assignRef('nullDate', $nullDate) ;			
		$this->assignRef('dateFormat', $dateFormat) ;	
		$this->assignRef('fields', $fields) ;	
		$this->assignRef('config', $config) ;

		if (version_compare(JVERSION, '3.0', 'ge')) {
			JHtml::_('bootstrap.tooltip', '.hasTooltip', array('placement' => 'top'));
		} else {
			PmFormHelper::loadTooltip('.hasTooltip', array('placement' => 'top'));
		}
		
		parent::display($tpl);				
	}
}