<?php
/**
 * @version		3.0
 * @package		Joomla
 * @subpackage	Payment Form
 * @author  Tuan Pham Ngoc
 * @copyright	Copyright (C) 2010 Ossolution Team
 * @license		GNU/GPL, see LICENSE.php
 */
// Check to ensure this file is included in Joomla!
defined('_JEXEC') or die ;
/**
 * HTML View class for Payment Form component
 *
 * @static
 * @package		Joomla
 * @subpackage	Payment Form
 * @since 1.5
 */
class PmFormViewPayment extends JViewLegacy
{
	function display($tpl = null)
	{		
		$db = JFactory::getDBO();
		$item = $this->get('Data');		
		$config = PmFormHelper::getConfig();
		$this->assignRef('item', $item);
		$this->assignRef('config', $config);						
		//Get list of campaign
		$sql = 'SELECT id , title FROM #__pf_forms WHERE published = 1 ';
		$db->setQuery($sql) ;
		$options = array() ;
		$options[] = JHTML::_('select.option', 0, JText::_('Select Form'), 'id' ,'title') ;
		$options =  array_merge($options, $db->loadObjectList()) ;
		$lists['form_id'] = JHTML::_('select.genericlist', $options, 'form_id', ' class="inputbox" ', 'id', 'title' , $item->form_id) ;
		//Get list of country
		$sql = 'SELECT name AS value, name AS text FROM #__pf_countries WHERE published = 1';
		$db->setQuery($sql);		
		$rowCountries = $db->loadObjectList();
		$options = array();
		$options[] =  JHTML::_('select.option', '', JText::_('Select country'));
		$options = array_merge($options, $rowCountries);
		$lists['country_list'] = JHTML::_('select.genericlist', $options, 'country', '', 'value', 'text', $item->country);
		//Get users
		$sql = 'SELECT id, username FROM #__users  WHERE block = 0 ORDER BY username';
		$db->setQuery($sql) ;
		$options = array();
		$options[] = JHTML::_('select.option', 0, JText::_('--Select user--'), 'id', 'username') ;
		$options = array_merge($options, $db->loadObjectList()) ;
		$lists['user_id'] =  JHTML::_('select.genericlist', $options, 'user_id', ' class="inputbox" ', 'id', 'username', $item->user_id);		
		$this->assignRef('item', $item);
		$this->assignRef('config', $config);
		$this->assignRef('lists', $lists);
		
		//Get all core fields for this form
		if ($item->form_id) {
		    $sql = 'SELECT a.name FROM #__pf_fields AS a INNER JOIN #__pf_form_fields AS b ON a.id=b.field_id WHERE a.is_core=1 AND b.published=1 AND b.form_id='.$item->form_id ;
		} else {
		    $sql = 'SELECT a.name FROM #__pf_fields AS a WHERE a.is_core=1 AND a.published=1';    
		}
		$db->setQuery($sql) ;
		if (version_compare(JVERSION, '3.0', 'ge')) {
			$coreFields = $db->loadColumn() ;
		} else {
			$coreFields = $db->loadResultArray() ;
		}					
												
		//Since 1.3
		$id = $this->get('id'); 
		$jcFields = new JCFields($item->form_id);
		if ($jcFields->getTotal()) {
			$customField = true ;			
			$fields = $jcFields->renderCustomFieldsEdit($id) ;										
			$this->assignRef('fields', $fields) ;		
		} else {
			$customField = false ;
		}
		$this->assignRef('customField', $customField) ;
		$this->assignRef('coreFields', $coreFields) ;
		parent::display($tpl);				
	}
}