<?php
/**
 * @copyright	Copyright (C) 2012 Daniel Calviño Sánchez
 * @license		GNU Affero General Public License version 3 or later; see LICENSE.txt
 */

defined('_JEXEC') or die;
 
jimport('joomla.application.component.controller');

/**
 * Main controller for display task and other tasks that just redirect to a
 * view.
 */
class ProductSearchController extends JControllerLegacy {

    /**
     * Displays the routes manager.
     */
    public function display() {
        //Set default view if not set
		require_once JPATH_COMPONENT.'/helpers/djcatalog2.php';
		Djcatalog2Helper::addSubmenu(JRequest::getCmd('view', 'routes'));
        JRequest::setVar('view', JRequest::getCmd('view', 'routes'));
		
        parent::display();
    }

    /**
     * Redirects to the routes manager.
     * Used when closing the test view from the toolbar.
     */
    public function routes() {
        $this->setRedirect(JRoute::_('index.php?option=com_productsearch&view=routes', false));
    }

    /**
     * Redirects to the routes test.
     * Used when showing the test view from the toolbar.
     */
    public function import() {
		$db = JFactory::getDBO();
		$query = 'SELECT i.*,CASE WHEN CHAR_LENGTH(i.alias) THEN CONCAT_WS(":", i.id, i.alias) ELSE i.id END as slug,img.fullname as item_image, img.caption AS image_caption, '.
				' c.id as _category_id, c.name as category, c.published as publish_category,CASE WHEN CHAR_LENGTH(c.alias) THEN CONCAT_WS(":", c.id, c.alias) ELSE c.id END as catslug'.
				' FROM #__djc2_items AS i '.
				' LEFT JOIN (select im1.fullname, im1.caption, im1.type, im1.item_id from #__djc2_images as im1, (select item_id, type, min(ordering) as lowest_order from #__djc2_images group by item_id, type) as im2 where im1.item_id = im2.item_id and im1.type=im2.type and im1.ordering = im2.lowest_order) AS img ON img.item_id = i.id AND img.type=\'item\''.
				' LEFT JOIN #__djc2_categories AS c ON c.id = i.cat_id '.
				' WHERE i.id NOT IN (SELECT product_id FROM #__simplecustomrouter) '.
				' ORDER BY i.id ASC ';
		$db->setQuery($query);
		$rows = $db->loadObjectList();
		foreach($rows as $row){
			$links = $this->genarateLinks($row);
			if(count($links) > 0){
				foreach($links as $link){
					$sql = 	" INSERT INTO #__simplecustomrouter(path,query,itemId,product_id) ".
							" VALUES('".$link['path']."','".$link['query']."','".$link['Itemid']."','".$row->id."')";
					$db->setQuery($sql);
					$db->query();
				}
			}
		}
		$this->setRedirect(JRoute::_('index.php?option=com_productsearch&view=routes', false));
    }
	public function genarateLinks(&$row){
		
		$links = array();
		$categories = $this->getCategories($row->cat_id);
		if(count($categories) > 0){
			foreach($categories as $category){
				$catslug = $category->id.':'.$category->alias;
				$link = DJCatalogHelperRoute::getItemRoute($row->slug,$catslug);
				$links[] = $this->parseLink($link,$row->slug,$catslug);
			}
		}else{
			$link = DJCatalogHelperRoute::getItemRoute($row->slug,$row->catslug);
			$links[] = $this->parseLink($link,$row->slug,$row->catslug);
		}
		return $links;
	}
	public function parseLink($link = '',$slug,$catslug){
		$link = str_replace("index.php?","",$link);			
		$pos = strpos($link,"Itemid");
		$query = substr($link,0,$pos-1);
		$slug = str_replace(":","-",$slug);
		$catslug = str_replace(":","-",$catslug);
		$path = 'item/'.$catslug.'/'.$slug;
		$Itemid = substr($link,$pos + 7);
		
		return array('query'=>$query,
					'path'=>$path,
					'Itemid'=>$Itemid);
	}
	public function getCategories($category_id = 0){
		$db = JFactory::getDBO();
		$result = array();
		$query = 	" SELECT c.id,c.alias ".
					" FROM #__djc2_categories AS c ".
					" WHERE c.id = {$category_id}";
		$db->setQuery($query);
		$row = $db->loadObject();
		if(count($row) > 0){
			$result[] = $row;
			$query1 = "SELECT parent_id FROM #__djc2_categories WHERE id = {$category_id} ";
			$db->setQuery($query1);
			$parent_id = $db->loadResult();
			if( $parent_id > 0){
				$result = array_merge($result,$this->getCategories($parent_id));
			}
		}
		return $result;
	}
}
