<?php
/**
 * @copyright	Copyright (C) 2012 Daniel Calviño Sánchez
 * @license		GNU Affero General Public License version 3 or later; see LICENSE.txt
 */

defined('_JEXEC') or die;
 
jimport('joomla.application.component.controller');
 
/**
 * Controller for the form to edit a route.
 * It uses Joomla infrastructure.
 */
class ProductSearchControllerLink extends JControllerLegacy {
	function __construct($config = array())
	{
		parent::__construct($config);
	}

	function display($cachable = true, $urlparams = null) {
		JRequest::setVar( 'layout', JRequest::getVar('layout','default'));
		JRequest::setVar( 'view'  , JRequest::getVar('view','link'));		
		parent::display($cachable, $urlparams);
	}
	public function cancel(){
		$this->setRedirect('index.php?option=com_productsearch&view=links');
	}
	public function add(){
		JRequest::setVar( 'layout', 'default');
		JRequest::setVar( 'view'  , 'link');
		$this->display();
	}
	public function edit(){
		JRequest::setVar( 'layout', 'default');
		JRequest::setVar( 'view'  , 'link');
		$this->display();
	}
	public function save(){
		$db = JFactory::getDBO();
		$model = $this->getModel('link');
		$producer_name = JRequest::getVar('producer_name',"");
		$product_line = JRequest::getVar('product_line',"");
		$product_model = JRequest::getVar('product_model',"");
		if(empty($producer_name) || empty($product_line) || empty($product_model)){
			JError::raiseWarning( 100, 'Invalid Form' );
			$this->setRedirect('index.php?option=com_productsearch&view=links');
			return false;
		}
		$product_selected = JRequest::getVar('product_selected',"");
		$producer_id = $model->createCategory($producer_name);
		$product_line_id = $model->createCategory($product_line,array('parent_id'=>$producer_id));
		$product_model_id = $model->createCategory($product_model,array('parent_id'=>$product_line_id));
		$products = JRequest::getVar('products',array());
		
		if(empty($producer_id) || empty($product_line_id) || empty($product_model_id) || empty($products) || empty($product_selected)){
			JError::raiseWarning( 100, 'Invalid Form' );
			$this->setRedirect('index.php?option=com_productsearch&view=links');
			return false;
		}
		$product_selected = explode(",",$product_selected);
		$products = array_merge($products,$product_selected);
		$products = array_unique($products);
		
		$IDs = $model->getIDItemsbyCategory($producer_id);
		foreach($IDs as $ID){
			if(in_array($ID,$products)){
				$model->deleteItem($ID);
				$model->insertItem($ID,$producer_id);
				$model->insertItem($ID,$product_line_id);
				$model->insertItem($ID,$product_model_id);
				$model->updateItem($ID,$product_model_id);
			}elseif($model->checkItem($ID,$producer_id,$product_line_id,$product_model_id) > 0){
				$model->deleteItem($ID);
			}
		}
		$this->setRedirect('index.php?option=com_productsearch&view=links',"Successful");
	}
	/*public function save(){
		$producer_id = JRequest::getVar('producer_id',0);
		$product_line_id = JRequest::getVar('product_line_id',0);
		$product_model_id = JRequest::getVar('product_model_id',0);
		$product_selected = JRequest::getVar('product_selected',"");
		$products = JRequest::getVar('products',array());
		
		if(empty($producer_id) || empty($product_line_id) || empty($product_model_id) || empty($products) || empty($product_selected)){
			JError::raiseWarning( 100, 'Invalid Form' );
			$this->setRedirect('index.php?option=com_productsearch&view=links');
			return false;
		}
		$product_selected = explode(",",$product_selected);
		$products = array_merge($products,$product_selected);
		$products = array_unique($products);
		$db = JFactory::getDBO();
		$model = $this->getModel('link');
		$IDs = $model->getIDItemsbyCategory($producer_id);
		foreach($IDs as $ID){
			if(in_array($ID,$products)){
				$model->deleteItem($ID);
				$model->insertItem($ID,$producer_id);
				$model->insertItem($ID,$product_line_id);
				$model->insertItem($ID,$product_model_id);
				$model->updateItem($ID,$product_model_id);
			}elseif($model->checkItem($ID,$producer_id,$product_line_id,$product_model_id) > 0){
				$model->deleteItem($ID);
			}
		}
		$this->setRedirect('index.php?option=com_productsearch&view=links',"Successful");
	}*/
	public function delete(){
		$cids = JRequest::getVar('cid',"");
		
		if(empty($cids)){			
			JError::raiseWarning( 100, 'Delete unsuccessful' );
			$this->setRedirect('index.php?option=com_productsearch&view=links');
		}
		if(!is_array($cids)){
			JError::raiseWarning( 100, 'Delete unsuccessful' );
			$this->setRedirect('index.php?option=com_productsearch&view=links');
		}
		$model = $this->getModel('link');
		foreach($cids as $cid){
			$IDs = explode(".",$cid);
			foreach($IDs as $ID){
				$model->deleteCategory($ID);
				$model->deleteItemByCategory($ID);
			}
		}
		$this->setRedirect('index.php?option=com_productsearch&view=links',"Successful");
	}
	public function getProductLine(){
		$category_id = JRequest::getVar('category_id',0);
		$selected = JRequest::getVar('selected',0);
		$model = $this->getModel('link');
		$categories = array();
		$categories[] = JHTML::_('select.option','','Select Product Line', 'id','name');
		if(!empty($category_id)){
			$categories = array_merge($categories,$model->getCategoriesByProducer($category_id));
		}
		echo JHTML::_('select.genericlist', $categories,'product_line_id', 'class="select-product-line"  onchange="javascript:productlinechange(this)"','id','name',$selected);
		exit();
	}
	public function getProductModel(){
		$category_id = JRequest::getVar('category_id',0);
		$selected = JRequest::getVar('selected',0);
		$model = $this->getModel('link');
		$categories = array();
		$categories[] = JHTML::_('select.option','','Select Model', 'id','name');
		if(!empty($category_id)){
			$categories = array_merge($categories,$model->getCategoriesByProducer($category_id));
		}
		echo JHTML::_('select.genericlist', $categories,'product_model_id', 'class="select-product-model" onchange="javascript:productsselected(this)"','id','name',$selected);
		exit();
	}
	public function getItems(){
		$model = $this->getModel('link');
		$start = JRequest::getVar('start',0);
		$limit = JRequest::getVar('limit',12);
		$producer_id = JRequest::getVar('producer_id',0);
		$product_line_id = JRequest::getVar('product_line_id',0);
		$product_model_id = JRequest::getVar('product_model_id',0);
		$current_checked = JRequest::getVar('current_checked',"");
		if(empty($current_checked)){
			$current_checked = array();
		}else{
			$current_checked = explode(",",$current_checked);
		}
		$has_checked = false;
		$items_checked = $current_checked;
		/*if(!empty($producer_id) && !empty($product_line_id) && !empty($product_model_id)){
			$has_checked = true;
			$items_checked = array_merge($items_checked,$model->getItemSelected($producer_id, $product_line_id, $product_model_id));
		}
		$items_checked = array_unique($items_checked);*/
		$items = $model->getItems($start,$limit);
		echo '<ul>';
		foreach($items as $item){
			$checked = '';
			if(in_array($item->id,$items_checked)){
				$checked = 'checked="checked"';
			}
			echo '<li style="width:300px;float:left;margin-right:10px;"><label for="product_'.$item->id.'"><input id="product_'.$item->id.'"  onclick="javascript:updateItemsChecked(this)"  type="checkbox" name="products[]" '.$checked.' value="'.$item->id.'" /> <strong>'.$item->id.'</strong>-'.$item->name.'</label></li>';
		}
		echo '</ul>';
		exit();
	}
	public function getFullItems(){
		$producer_id = JRequest::getVar('producer_id',0);
		$product_line_id = JRequest::getVar('product_line_id',0);
		$product_model_id = JRequest::getVar('product_model_id',0);
		$model = $this->getModel('link');
		$items = $model->getItemsbyCategory($producer_id);
		$items_selected = $model->getItemSelected($producer_id,$product_line_id,$product_model_id);
		echo '<ul>';
		foreach($items as $item){
			$checked = '';
			if(in_array($item->id,$items_selected)){
				$checked = 'checked="checked"';
			}
			echo '<li style="width:300px;float:left;margin-right:10px;"><label for="product_'.$item->id.'"><input id="product_'.$item->id.'" type="checkbox" name="products[]" '.$checked.' value="'.$item->id.'" /> '.$item->name.'</label></li>';
		}
		echo '</ul>';
		exit();
	}
	public function getItemsChecked(){
		$producer_id = JRequest::getVar('producer_id',0);
		$product_line_id = JRequest::getVar('product_line_id',0);
		$product_model_id = JRequest::getVar('product_model_id',0);
		$model = $this->getModel('link');
		$items_selected = $model->getItemSelected($producer_id,$product_line_id,$product_model_id);
		exit(implode(",",$items_selected));
	}
	
}
