<?php
/**
 * @copyright	Copyright (C) 2012 Daniel Calviño Sánchez
 * @license		GNU Affero General Public License version 3 or later; see LICENSE.txt
 */

defined('_JEXEC') or die;
 
jimport('joomla.application.component.model');

/**
 * Model for the form to edit a route.
 * It uses Joomla infrastructure, and fields are defined in forms/route.xml.
 */
class ProductSearchModelLink extends JModelLegacy {
	public function getManufacture(){
		$db = JFactory::getDBO();
		$query = "SELECT id,name FROM #__djc2_categories_custom WHERE parent_id = 0 ORDER BY ordering ASC";
		$db->setQuery($query);
		return $db->loadObjectList();	
	}
	public function getCategoriesByProducer($producer_id = 0){
		$db = JFactory::getDBO();
		$query = "SELECT id,name FROM #__djc2_categories_custom WHERE parent_id = {$producer_id}";
		$db->setQuery($query);
		return $db->loadObjectList();
	}
	public function checkItem($item_id = 0,$manfacture_id = 0,$product_line = 0,$model = 0){
		/*$list = array();
		$list[] = $manfacture_id.",".$product_line.",".$model;
		$list[] = $manfacture_id.",".$model.",".$product_line;
		$list[] = $model.",".$manfacture_id.",".$product_line;
		$list[] = $model.",".$product_line.",".$manfacture_id;
		$list[] = $product_line.",".$model.",".$manfacture_id;
		$list[] = $product_line.",".$manfacture_id.",".$model;*/
		$where_clause = "";
		if(!empty($model)){
			$where_clause = " AND category_id = ".$model;
		}elseif(!empty($product_line)){
			$where_clause = " AND category_id = ".$product_line;
		}elseif(!empty($manfacture_id)){
			$where_clause =  " AND category_id = ".$manfacture_id;
		}
		$db = JFactory::getDBO();
		$query = 	" SELECT item_id ".
					" FROM #__djc2_items_categories_custom ".
					" WHERE item_id = {$item_id}".$where_clause;
					//" HAVING GROUP_CONCAT(category_id) IN ('".implode('\',\'',$list)."')";
		$db->setQuery($query);
		$rows = $db->loadObjectList();
		return count($rows);
	}
	public function insertItem($item_id = 0,$category_id = 0){
		$db = JFactory::getDBO();
		$query = "INSERT INTO #__djc2_items_categories_custom(item_id,category_id) VALUES({$item_id},{$category_id})";
		$db->setQuery($query);
		return $db->query();
	}
	public function updateItem($item_id = 0,$category_id = 0){
		$db = JFactory::getDBO();
		$query = "UPDATE #__djc2_items SET cat_id ={$category_id} WHERE id = {$item_id}";
		$db->setQuery($query);
		return $db->query();
	}
	public function getItemsbyCategory($category_id = 0){
		$db = JFactory::getDBO();
		$query = "SELECT i.id,i.name ".
				" FROM #__djc2_items_categories_custom AS c ".
				" LEFT JOIN #__djc2_items AS i ON i.id = c.item_id ".
				" WHERE category_id = {$category_id}".
				" GROUP BY i.id";
		$db->setQuery($query);
		return $db->loadObjectList();	
	}
	public function getIDItemsbyCategory(){
		$db = JFactory::getDBO();
		$query = "SELECT i.id ".
				" FROM #__djc2_items AS i ".
				" WHERE i.published = 1";
		$db->setQuery($query);
		return $db->loadResultArray();	
	}
	public function deleteItem($item_id = 0){
		$db = JFactory::getDBO();
		$query = "DELETE FROM #__djc2_items_categories_custom WHERE item_id = {$item_id} ";
		$db->setQuery($query);
		return $db->query();
	}
	public function deleteCategory($id = 0){
		$db = JFactory::getDBO();
		$query = "DELETE FROM #__djc2_categories_custom WHERE id = {$id} ";
		$db->setQuery($query);
		return $db->query();
	}
	public function deleteItemByCategory($id = 0){
		$db = JFactory::getDBO();
		$query = "DELETE FROM #__djc2_items_categories_custom WHERE category_id = {$id} ";
		$db->setQuery($query);
		return $db->query();
	}
	public function getItemSelected($manfacture_id = 0,$product_line = 0,$model = 0){
		$db = JFactory::getDBO();
		/*$list = array();
		$list[] = $manfacture_id.",".$product_line.",".$model;
		$list[] = $manfacture_id.",".$model.",".$product_line;
		$list[] = $model.",".$manfacture_id.",".$product_line;
		$list[] = $model.",".$product_line.",".$manfacture_id;
		$list[] = $product_line.",".$model.",".$manfacture_id;
		$list[] = $product_line.",".$manfacture_id.",".$model;*/
		$where_clause = "";
		if(!empty($model)){
			$where_clause = " WHERE category_id = ".$model;
		}elseif(!empty($product_line)){
			$where_clause = " WHERE category_id = ".$product_line;
		}elseif(!empty($manfacture_id)){
			$where_clause =  " WHERE category_id = ".$manfacture_id;
		}
		$query = " SELECT ic.item_id AS id ".
				 " FROM #__djc2_items_categories_custom AS ic ".
				 " LEFT JOIN #__djc2_items AS i ON i.id = ic.item_id ".
				 $where_clause.
				 " GROUP BY ic.item_id ";
				 //" HAVING GROUP_CONCAT(category_id) IN ('".implode('\',\'',$list)."')";
		$db->setQuery($query);
		return $db->loadResultArray();				 
	}
	public function getCategory($id = 0){
		$db = JFactory::getDBO();
		$query = "SELECT id,name FROM #__djc2_categories_custom WHERE id = {$id} LIMIT 1";
		$db->setQuery($query);
		return $db->loadObject();
	}
	public function createCategory($name = "",$data = array()){
		$db = JFactory::getDBO();
		$query = "SELECT id FROM #__djc2_categories_custom WHERE name = '{$name}'";
		$db->setQuery($query);
		$id = $db->loadResult();
		if(!empty($id)){
			return $id;
		}
		$table = JTable::getInstance('CategoriesCustom', 'ProductSearchTable');
		$data['name']= $name;
		$data['published']= 1;
		$table->bind($data);
		$table->store();
		$table->reorder();
		return $table->id;
	}
	public function getItems($start = 0,$limit = 0){
		$db = JFactory::getDBO();
		$query = "SELECT id,name FROM #__djc2_items WHERE published = 1";
		$db->setQuery($query,$start,$limit);
		return $db->loadObjectList();
	}
	public function getTotalItems(){
		$db = JFactory::getDBO();
		$query = "SELECT count(*) as total FROM #__djc2_items WHERE published = 1";
		$db->setQuery($query);
		return $db->loadResult();
	}
}
