<?php
/**
 * @version     1.8
 * @package     com_rapidcontactex
 * @copyright   Copyright (C) 2013. All rights reserved.
 * @license     GNU General Public License version 2 or later; see LICENSE.txt
 * @author      Christopher Mavros <mavrosxristoforos@gmail.com> - http://mavrosxristoforos.com
 */

// No direct access
defined('_JEXEC') or die;

jimport('joomla.application.component.controllerform');

class RapidcontactexControllerDefault extends JControllerForm
{

    function __construct() {
        $this->view_list = 'default';
        parent::__construct();

        $this->registerTask( 'add'  ,   'edit' );
    }

    public function edit($key = NULL, $urlVar = NULL)
    {
        JRequest::setVar( 'view', 'rapidcontactex' );
        JRequest::setVar( 'layout', 'form'  );
        JRequest::setVar('hidemainmenu', 1);

        parent::display();
    }

    public function qreq()
    {
        $array = JRequest::getVar('cid',  0, '', 'array');
        $mId = (int)$array[0];

        $db = JFactory::getDBO();

        $query = 'UPDATE `#__rcx_fields` SET `required` = "1" WHERE `id` = "'.$mId.'"';

        $db->setQuery($query);

        if ($db->query()) {
          $msg = 'Field(s) set as required';
        }
        else {
          $msg = 'Error setting Field(s) as required';
        }


        $link = 'index.php?option=com_rapidcontactex&view=default';
        $this->setRedirect($link, $msg);
    }

    public function qureq()
    {
        $array = JRequest::getVar('cid',  0, '', 'array');
        $mId = (int)$array[0];

        $db = JFactory::getDBO();

        $query = 'UPDATE `#__rcx_fields` SET `required` = "0" WHERE `id` = "'.$mId.'"';

        $db->setQuery($query);

        if ($db->query()) {
          $msg = 'Field(s) set as not required';
        }
        else {
          $msg = 'Error setting Field(s) as not required';
        }


        $link = 'index.php?option=com_rapidcontactex&view=default';
        $this->setRedirect($link, $msg);
    }

    public function save($key = NULL, $urlVar = NULL)
    {
        $model = $this->getModel('default');

        if ($model->store($post)) {
            $msg = JText::_( 'Field Saved!' );
        } else {
            $msg = JText::_( 'Error Saving Field' );
        }

        $link = 'index.php?option=com_rapidcontactex';
        $this->setRedirect($link, $msg);
    }

    public function remove()
    {
         $model = $this->getModel('default');
         if(!$model->delete()) {
             $msg = JText::_( 'Error: One or More Fields Could not be Deleted' );
         } else {
             $msg = JText::_( 'Field(s) Deleted' );
         }

         $this->setRedirect( 'index.php?option=com_rapidcontactex', $msg );
    }

    public function cancel($key = NULL)
    {
      $msg = JText::_( 'Operation Cancelled' );
      $this->setRedirect( 'index.php?option=com_rapidcontactex', $msg );
    }

    public function publish()
    {
        $model = $this->getModel('default');

        if ($model->publish(( $this->getTask() == 'publish' ? 1 : 0 ))) {
            $msg = JText::_( 'Field(s) Published!' );
        } else {
            $msg = JText::_( 'Error Publishing Field(s)' );
        }

        $this->setRedirect( 'index.php?option=com_rapidcontactex', $msg );
    }

    public function unpublish()
    {
        $model = $this->getModel('default');

        if ($model->publish(( $this->getTask() == 'publish' ? 1 : 0 ))) {
            $msg = JText::_( 'Field(s) Unpublished!' );
        } else {
            $msg = JText::_( 'Error Unpublishing Field(s)' );
        }

        $this->setRedirect( 'index.php?option=com_rapidcontactex', $msg );
    }

}