<?php
/**
 * Joomla! 1.5 component Rapid Contact Ex
 *
 * @version $Id: controller.php 2009-06-03 03:24:57 svn $
 * @author Christopher Mavros
 * @package Joomla
 * @subpackage Rapid Contact Ex
 * @license GNU/GPL
 *
 * A simple component to register fields for the Rapid Contact Ext Module.
 *
 * This component file was created using the Joomla Component Creator by Not Web Design
 * http://www.notwebdesign.com/joomla_component_creator/
 *
 */

defined('_JEXEC') or die;

class RapidContactExHelper
{
  /**
   * Configure the Linkbar.
   *
   * @param string  The name of the active view.
   */
  public static function addSubmenu($vName = 'default') {
    JSubMenuHelper::addEntry(JText::_('FIELD_MANAGER'), 'index.php?option=com_rapidcontactex', $vName == 'default');
  }

  /**
   * Gets a list of the actions that can be performed.
   *
   * @return  JObject
   * @since 1.6
   */
  public static function getActions()
  {
    $user = JFactory::getUser();
    $result = new JObject;

    $assetName = 'com_rapidcontactex';

    $actions = JAccess::getActions($assetName);

    foreach ($actions as $action) {
      $result->set($action->name, $user->authorise($action->name, $assetName));
    }

    return $result;
  }
}
